
        include    \masm32\include\masm32rt.inc
        include    \masm32\include\msimg32.inc
        includelib \masm32\lib\msimg32.lib

WinMain    proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc    proto :HWND,:UINT,:WPARAM,:LPARAM

MAINBITMAP equ   500             ; BITMAP

        .data

ClassName   db "MainWinClass",0
AppName     db "Main Window",0
ClassStatic db "Static",0
ClassButt   db "Button",0
NameStatic1 db "Mydraw1",0
NameStatic2 db "Mydraw2",0

        .data?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?
hstatic1    HWND      ?
hstatic2    HWND      ?
hbutton     HWND      ?
hBit        HBITMAP   ?
dwBmpWidth  dd        ?
dwBmpHeight dd        ?

        .code

start:  invoke  GetModuleHandle,NULL
        mov     hInstance,eax	
        invoke  GetCommandLine
        mov     CommandLine,eax
        invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
        invoke  ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

        LOCAL   wc   :WNDCLASSEX
        LOCAL   msg  :MSG
        LOCAL   hwnd :HWND

        mov     wc.cbSize,SIZEOF WNDCLASSEX
        mov     wc.style, CS_HREDRAW or CS_VREDRAW
        mov     wc.lpfnWndProc, OFFSET WndProc
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        push    hInst
        pop     wc.hInstance
        mov     wc.hbrBackground,COLOR_BTNFACE+1
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,OFFSET ClassName
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx, addr wc

        invoke  CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,
                WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,
                100h,100h,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        invoke  ShowWindow, hwnd,SW_SHOWNORMAL
        invoke  UpdateWindow, hwnd

    .while TRUE
        invoke  GetMessage,ADDR msg,NULL,0,0
    .break .if (!eax)
        invoke  TranslateMessage,ADDR msg
        invoke  DispatchMessage,ADDR msg
    .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        LOCAL   hBmpOrg  :HBITMAP
	LOCAL   Bm       :BITMAP
	LOCAL   ps       :PAINTSTRUCT
	LOCAL   hdc10    :HDC
	LOCAL   hMem10   :HDC

    .if uMsg==WM_DESTROY
        invoke  DeleteObject,hBit
        invoke  PostQuitMessage,NULL

    .elseif uMsg==WM_CREATE
        invoke  CreateWindowEx,NULL,addr ClassButt,addr AppName,
                WS_CHILD or WS_VISIBLE,60,50,100,26,hWnd,NULL,hInstance,NULL
        mov     hbutton,eax
        invoke  LoadBitmap,hInstance,MAINBITMAP
        mov     hBit,eax
        invoke  GetObject,hBit,sizeof Bm,addr Bm
        push    Bm.bmWidth
        pop     dwBmpWidth
        push    Bm.bmHeight
        pop     dwBmpHeight

    .elseif uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
        mov     hdc10,eax
        invoke  CreateCompatibleDC,hdc10
        mov     hMem10,eax
        invoke  SelectObject,hMem10,hBit
        mov     hBmpOrg,eax
        invoke  TransparentBlt,hdc10,0,0,dwBmpWidth,dwBmpHeight,
                hMem10,0,0,dwBmpWidth,dwBmpHeight,0FF00FFh        ;transparent color
        invoke  SelectObject,hMem10,hBmpOrg
        invoke  DeleteDC,hMem10
        invoke  EndPaint,hWnd,addr ps

    .else
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
        ret

    .endif

    xor     eax,eax
    ret

WndProc endp

        end   start

